//----------------------------------------------------------------
//  HEART
//       programed by M I,May 22 '90
// Oh!X 1990-8
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if not isLocalizeJapan() then {
	// このゲームは日本語メッセージが多く、その幅の調整をするのが非常に面倒なので英語対応は完全ではない。
	// 故にこのメッセージを出しておく。
	cls()
	locate(0,5)
	print "In this game, some messages are Japanese only."
	hitKey(NO)
}

//----------------------------------------------------------------

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int jj,b1,b2,b3,b4,bb,m,f=0,rd=1
dim int cc(51),c(3,12),pp(51),p(3,12),gg(3)
dim int h(12),b(3),mai(3),kei(3),kuri(4),ten(4,3)
dim str nam(3) = {"太郎","次郎","花子","貴方"}
dim str nams(3)
if not isLocalizeJapan() then {
	nam ={"Taro","Jiro","Hana","You "}
	nams={"Taro's","Jiro's","Hana's","Your"}
}

// 音声データ読み込み
dim int snd(8)
int i
for i=1 to 8
	snd(i)=-1
//	gLocate(0,35+i)
//	print "heart"+str$(i)+".mp3";
	if i=2 then continue:// 1<-1+2なので2はない
	snd(i)=a_setPlayData("heart"+str$(i)+".mp3")
//	print "/";snd(i)
next

setgPalet16X68(1,&h000000ff):// palet(1,0)

// main program

while f<>1
	scrn()
	play()
	jd3()
endwhile
owari()

// 音声バッファー開放
for i=1 to 8
	if snd(i)<0 then continue
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

//------------------------------------
// screen

func scrn()
	int i
	apage(GPAGE3):vpageX68(15)
	fill16X68(0,0,511,511,3)
	apage(GPAGE2)
	box16X68(0,0,511,511,15)
	box16X68(1,1,510,510,15)
	line16X68(  2,144,509,144,15)
	line16X68(160,  2,160,143,15)
	line16X68(320,  2,320,143,15)
	line16X68(  2,384,509,384,15)
	line16X68(280,145,280,383,15)
	for i=0 to 4
		line16X68(321,i*24+24,509,i*24+24,15)
	next
	for i=0 to 5
		line16X68(i*30+360,25,i*30+360,143,15)
	next
	symbol16X68(22,42,"ＨＥＡＲＴ",1.5, 1,FONT,FNTSZ)
	symbol16X68(20,40,"ＨＥＡＲＴ",1.5,13,FONT,FNTSZ)
	symbol16X68(380,6,"ＳＣＯＲＥ",1  ,15,FONT,FNTSZ)
	for i=0 to 3:symbol16X68(     324,i*24+53, nam(i),1,15,FONT,FNTSZ):next
	for i=1 to 4:symbol16X68(i*30+341,     29,str$(i),1,15,FONT,FNTSZ):next
	if isLocalizeJapan() then {
	symbol16X68(481,29,"合計",0.8,15,FONT,FNTSZ)
	} else {
	symbol16X68(481,31,"Total",0.7,15,FONT,FNTSZ)
	}
	symbol16X68(348,154,localizedString("各自のハート","Each heart card"),1,15,FONT,FNTSZ)
	for i=0 to 3
		symbol16X68((i mod 2)*112+286,(i \ 2)*104+204,nam(i),1,15,FONT,FNTSZ)
	next
	symbol16X68(8,428,nam(3),1,15,FONT,FNTSZ)
	for i=0 to 3:kei( i)=0:next
	for i=0 to 4:kuri(i)=0:next
endfunc

//------------------------------------
// play

func play()
	while rd<5
		prep()
		splay()
		jd2()
	endwhile
endfunc

//------------------------------------

func prep()
int i,j,a,b,k,s
	/* deal
	apage(GPAGE1)
	fill16X68((rd-1)*30+331,25,(rd-1)*30+359,47,0)
	fill16X68( rd   *30+331,25, rd   *30+359,47,5)
	for i=1 to 4:symbol16X68(i*30+341,29,str$(i),1,15,FONT,FNTSZ):next
	if rd=1 then {
		s=sel(localizedString("ルールの説明","Description of the rule"),1,1):if s=1 then rule()
	}
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	for i=0 to 51:cc(i)=i+1:next
	for i=0 to 3:mai(i)=0:next:m=13
	if s=2 or rd>1 then {
		er_upms()
		if isLocalizeJapan() then {
		symbol16X68(200,24,"シャッフル"	,1,15,FONT,FNTSZ)
		symbol16X68(224,56,"及び"		,1,15,FONT,FNTSZ)
		symbol16X68(200,88,"カード配布"	,1,15,FONT,FNTSZ)
		} else{
		symbol16X68(200,24,"Shuffle"		,1,15,FONT,FNTSZ)
		symbol16X68(224,56," and"			,1,15,FONT,FNTSZ)
		symbol16X68(200,88,"deal cards"	,1,15,FONT,FNTSZ)
		}
	}
	fill16X68(40,168,240,200,5)
	symbol16X68(64,176,localizedString("ちょっと待ってください","Wait a moment"),1,15,FONT,FNTSZ)
	for i=0 to 12:h(i)=0:next
	for i=0 to 99
		a=int(rnd()*52):b=int(rnd()*52)
		k=cc(a):cc(a)=cc(b):cc(b)=k
	next
	fill16X68(40,168,68,200,3)
	for i=0 to 51
		if cc(i)=1  then pp(i)=13:continue
		if cc(i)=14 then pp(i)=26:continue
		if cc(i)=27 then pp(i)=39:continue
		if cc(i)=40 then pp(i)=52:continue
		pp(i)=cc(i)-1
	next
	fill16X68(69,168,96,200,3)
	for i=0 to 12
		c(0,i)=cc(i)   :p(0,i)=pp(i)
		c(1,i)=cc(i+13):p(1,i)=pp(i+13)
		c(2,i)=cc(i+26):p(2,i)=pp(i+26)
		c(3,i)=cc(i+39):p(3,i)=pp(i+39)
	next
	for i=0 to 11
		for j=i+1 to 12
			for k=0 to 3
				if p(k,i)>p(k,j) then {
					a=p(k,i):p(k,i)=p(k,j):p(k,j)=a
					a=c(k,i):c(k,i)=c(k,j):c(k,j)=a
				}
			next
		next
	fill16X68(96,168,96+(i+1)*12,200,3)
	next
	er_upms()
	plcd()
	if s=1 then {
		click()
		apage(GPAGE0)
		fill16X68(0,0,511,511,0)
		apage(GPAGE1)
	}
	mkba():htmai()
	/* play order
	if rd=1 then {
		if isLocalizeJapan() then {
		symbol16X68(184,24,"順番を決めます"	,1,15,FONT,FNTSZ)
		symbol16X68(176,56,"いい時に画面を"	,1,15,FONT,FNTSZ)
		symbol16X68(208,88,"タップ"			,1,15,FONT,FNTSZ)
		symbol16X68(140,177,"が最初"		,1, 1,FONT,FNTSZ)
		} else {
		symbol16X68(176,24,"Decided to order"	,1,15,FONT,FNTSZ)
		symbol16X68(176,56,"Tap screen"		,1,15,FONT,FNTSZ)
		symbol16X68(176,88," when you want"	,1,15,FONT,FNTSZ)
		symbol16X68(140,177," is first"		,1, 1,FONT,FNTSZ)
		}
		// 前のタッチが離されるのを待つ
		while getTouchStatus()<>TOUCH_NONE:endwhile
		// タッチされるのを待つ
		repeat
			jj=int(rnd()*4)
			fill16X68(96,177,128,192,15)
			symbol16X68(96,177,nam(jj),1,1,FONT,FNTSZ)
		until getTouchStatus()<>TOUCH_NONE
		cwait(50):er_upms()
	} else symbol16X68(96,177,nam(jj)+localizedString("が最初"," is first"),1,1,FONT,FNTSZ):cwait(60)
endfunc

//------------------------------------
// play

func splay()
	repeat
		b1=0:b2=0:b3=0:b4=0:bb=1
		ssplay()
		jd1()
		m=m-1
	until m=0
endfunc

//------------------------------------

func ssplay()
	while bb<5
	if jj>=0 and jj<=2 then {
		if bb=1 then {
			com1():bb=2:jj=jj+1
			if jj=3 then you():jj=0:bb=3:continue
		} else if bb=2 then {
			com(2,b2):bb=3:jj=jj+1
			if jj=3 then you():jj=0:bb=4:continue
		} else if bb=3 then {
			com(3,b3):bb=4:jj=jj+1
			if jj=3 then you():bb=5
		} else if bb=4 then com(4,b4):bb=5
	} else if jj=3 and bb=1 then you():jj=0:bb=2:continue
	endwhile
endfunc

//------------------------------------
// com play as 1st player

func com1()
int i,is,hm=0,sm=0,bc=0
	dsban(jj)
	for i=0 to m-1
		if p(jj,i)>13 and p(jj,i)<27 then hm=hm+1
		if p(jj,i)<14 then sm=sm+1
	next
	while bc=0
		if hm>0 then {
			i = sm
			if p(jj,i)<17 then bc=1:break
			if p(jj,i)<18 and h(0)+h(1)+h(2)>=1 then bc=1:break
			if p(jj,i)<19 and h(0)+h(1)+h(2)>=2 then bc=1:break
			if p(jj,i)<20 and h(0)*h(1)*h(2)>0  then bc=1:break
			if p(jj,i)<21 and h(0)*h(1)*h(2)*h(3)>0 then bc=1:break
			if p(jj,i)<22 and h(0)*h(1)*h(2)*h(3)*h(4)>0 then bc=0:break
			if m<=5 and m=hm then bc=1:break
		}
		repeat
			i=int(rnd()*m)
		until p(jj,i)<14 or p(jj,i)>26
		bc=1
	endwhile
	is=i:bacd(jj,is)
	b1=p(jj,is):p(jj,is)=0:c(jj,is)=0:b(jj)=b1
	if b1>13 and b1<27 then gg(jj)=b1:h(b1-14)=1
	for i=0 to m-1:cc(i)=c(jj,i):pp(i)=p(jj,i):next
	cdleft(is)
	for i=0 to m-1:c(jj,i)=cc(i):p(jj,i)=pp(i):next
	if jj=2 then cwait(15) else cwait(30)
endfunc

//------------------------------------
// com play as 2nd to 4th player

func com(q,id)
int i,is,hm=0,sm=0,ap=0,bc=0
	dsban(jj)
	for i=0 to m-1
	if p(jj,i)>13 and p(jj,i)<27 then hm=hm+1
	if p(jj,i)<14 then sm=sm+1
	if (p(jj,i)-1)\13 = (b1-1)\13 then ap=ap+1
	next
	while bc=0
		if ap=0 then {
			if sm+hm>0 then is=sm+hm-1:b(jj)=0:bc=1:break else {
			is=m-1:b(jj)=0:bc=1:break }
		}
		if ap>0 and (b1>13 and b1<27) then {
			switch q
				case 2:is=scom2(hm,sm):break
				case 3:is=scom3(hm,sm):break
				case 4:is=scom4(hm,sm)
			endswitch
			if is>0 then bc=1
			if bc=0 and p(jj,sm)<22 then is=sm:bc=1:break
			if bc=0 and p(jj,sm)>21 then is=sm+hm-1:bc=1:break
		}
		if ap>0 and (b1<14 or b1>26) then {
			switch q
				case 2:is=sscom2():break
				case 3:is=sscom3():break
				case 4:is=sscom4()
			endswitch
			bc=1
		}
	endwhile
	bacd(jj,is)
	id=p(jj,is):p(jj,is)=0:c(jj,is)=0
	if ap>0 then b(jj)=id
	if id>13 and id<27 then gg(jj)=id:h(id-14)=1
	for i=0 to m-1:cc(i)=c(jj,i):pp(i)=p(jj,i):next
	cdleft(is)
	for i=0 to m-1:c(jj,i)=cc(i):p(jj,i)=pp(i):next
	if jj=2 then cwait(15) else cwait(30)
endfunc

//------------------------------------
// play you

func you()
int i,is,x,y,l,r,ap=0,bc=0
	dsban(3)
	if b1>0 then {
		for i = 0 to m-1
			if (p(3,i)-1)\13 = (b1-1)\13 then ap=ap+1
		next
	}
	while bc=0
		if isLocalizeJapan() then {
		symbol16X68(176,48,"出したいカードを"	,1,15,FONT,FNTSZ)
		symbol16X68(208,84,"タップ"				,1,15,FONT,FNTSZ)
		} else {
		symbol16X68(176,48,"Tap your"			,1,15,FONT,FNTSZ)
		symbol16X68(176,84,"  selected card"	,1,15,FONT,FNTSZ)
		}
		
		while getTouchStatus()=TOUCH_NONE
		endwhile

		dim float tpoint(1)
		int touchCnt=getTouchPoint(tpoint)
		x=tpoint(0)
		y=tpoint(1)
		
		er_upms()

		if m>9 then is=(x-48)\34 else is=(x-48)\50
		if is>m-1 then dame():cwait(40):er_upms():continue
		if b1>0 and ap>0 and (p(3,is)-1)\13 <>(b1-1)\13 then {
			dame():cwait(40):er_upms():continue
		} else bacd(3,is):b(3)=p(3,is):bc=1
		if b1>0 and ap=0 then b(3)=0
		switch bb
			case 1 :b1=p(3,is):break
			case 2 :b2=p(3,is):break
			case 3 :b3=p(3,is):break
			case 4 :b4=p(3,is)
		endswitch
		if p(3,is)>13 and p(3,is)<27 then gg(3)=p(3,is):h(gg(3)-14)=1
		p(3,is)=0:c(3,is)=0
		for i=0 to m-1:cc(i)=c(3,i):pp(i)=p(3,i):next
		cdleft(is)
		for i=0 to m-1:c(3,i)=cc(i):p(3,i)=pp(i):next
		fill16X68(2,385,509,509,0):m=m-1
		plcd():m=m+1
	endwhile
endfunc

//------------------------------------
// judge1

func jd1()
int i,j,a
	dim int ba(3)
	for i=0 to 3:ba(i)=b(i):next
	for i=0 to 2
		for j=i+1 to 3
			if b(i)<b(j) then a=b(i):b(i)=b(j):b(j)=a
		next
	next
	for jj=0 to 3
		if b(0)=ba(jj) then kachi(jj):cwait(49):break
	next
	a=mai(jj)
	for i=0 to 3
		if gg(i)>0 then {
			mai(jj)=mai(jj)+1:htcd(jj,i):htmai():gg(i)=0
		}
	next
	if mai(jj)>a then ha(mai(jj)-a):cwait(40) else ha0():cwait(40)
	mkba()
endfunc

//------------------------------------
// judge2

func jd2()
int i,j,a,b,cla,s
	a_play(snd(6))
	apage(GPAGE0)
	fill16X68(2,145,509,383,8)
	box16X68( 64,208,448,352,15)
	line16X68(65,256,447,256,15)
	for i=0 to 2
		line16X68( 65,i*24+280,239,i*24+280,15)
		line16X68(313,i*24+280,375,i*24+280,15)
	next
	line16X68(120,209,120,352,15)
	line16X68(176,209,176,352,15)
	line16X68(240,209,240,352,15)
	line16X68(312,209,312,352,15)
	line16X68(376,209,376,352,15)
	symbol16X68(160,168,"第"+str$(rd)+"回 得点計算",1.5,15,FONT,FNTSZ)
	symbol16X68(124,217,localizedString("ハート","Heart")	,1,15,FONT,FNTSZ)
	symbol16X68(124,237,"枚　数"	,1,15,FONT,FNTSZ)
	symbol16X68(184,217,"今回の"	,1,15,FONT,FNTSZ)
	symbol16X68(184,237,localizedString("得　点","Score")	,1,15,FONT,FNTSZ)
	symbol16X68(244,217,"前回から"	,1,15,FONT,FNTSZ)
	symbol16X68(244,237,"の繰越点"	,1,15,FONT,FNTSZ)
	symbol16X68(320,217,"修正後"	,1,15,FONT,FNTSZ)
	symbol16X68(320,237,"の得点"	,1,15,FONT,FNTSZ)
	symbol16X68(380,217,"次回への" 	,1,15,FONT,FNTSZ)
	symbol16X68(388,237,"繰越点"	,1,15,FONT,FNTSZ)
	//
	int ofx,ofx2
	for i=0 to 3
		symbol16X68(76,i*24+261,nam(i),1,15,FONT,FNTSZ)
		if mai(i)>9 then ofx=-16:// 10以上の時は前に1桁ずらす
		symbol16X68(148+ofx,i*24+261-5,str$(mai(i)),1.5,15,FONT,FNTSZ)
		if mai(i)=0 then cla=cla+1
	next
	if cla=0 then {
		kuri(rd)=13+kuri(rd-1)
		for i=0 to 3:ten(rd,i)=-mai(i):next
	}
	if cla=3 then {
		kuri(rd)=0
		for i=0 to 3
			if mai(i)=13 then ten(rd,i)=12 else ten(rd,i)=-4
		next
	}
	if cla>0 and cla<3 then {
		kuri(rd)=13 mod cla + kuri(rd-1) mod cla
		for i=0 to 3
			if mai(i)=0 then ten(rd,i)=13\cla else ten(rd,i)=-mai(i)
		next
	}
	//
	symbol16X68(264,297,str$(kuri(rd-1)),1.5,15,FONT,FNTSZ):// 前回からの繰り越し点
	symbol16X68(398,297,str$(kuri(rd))  ,1.5,15,FONT,FNTSZ):// 次回への繰り越し点
	for i=0 to 3
		ofx2=0
		if ten(rd,i)>0 then ofx2=12:// 得点が正の時は符号の分右へずらす
		symbol16X68(184+ofx2,i*24+261-5,str$(ten(rd,i)),1.5,15,FONT,FNTSZ):// 下の今回の得点
	next
	//
	if cla=3 then {
		for i=0 to 3
			if ten(rd,i)>0 then ten(rd,i)=ten(rd,i)+kuri(rd-1):break
		next
	}
	if cla>0 and cla<3 then {
		for i=0 to 3
			if ten(rd,i)>0 then ten(rd,i)=ten(rd,i)+kuri(rd-1)\cla
		next
	}
	// 修正後の得点
	for i=0 to 3
		kei(i)=kei(i)+ten(rd,i)
		ofx=0:ofx2=0
		if ten(rd,i)>0 then ofx=8:ofx2=12:// 得点が正の時は符号の分右へずらす
		symbol16X68(      320+ofx2,i*24+261-5,str$(ten(rd,i)),1.5,15,FONT,FNTSZ):// 下の修正後の得点
		symbol16X68(rd*30+334+ofx ,i*24+53 +1,str$(ten(rd,i)),1  ,15,FONT,FNTSZ):// 上の得点表
		fill16X68(481,i*24+49,509,i*24+71,0)
		ofx=0
		if kei(i)>0 then ofx=8
		symbol16X68(485+ofx,i*24+53+1,str$(kei(i)),1,15,FONT,FNTSZ):// 上の合計点
	next
	//
	rd=rd+1
	if rd<5 then {
		ten(rd-1,3)=ten(rd-1,3)+1
		for i=0 to 3:cc(i)=ten(rd-1,i):next
		for i=0 to 2
			for j=i+1 to 3
				if cc(i)<cc(j) then a=cc(i):cc(i)=cc(j):cc(j)=a
			next
		next
		for i=0 to 3
			if cc(0)=ten(rd-1,i) then jj=i:break
		next
		ten(rd-1,3)=ten(rd-1,3)-1
		s=sel(localizedString(str$(rd)+"回目を始めます","Start next time."),2,2)
		if s=2 then f=1:rd=5
	} else click()
	apage(GPAGE1):fill16X68(0,  0,511,511,0)
	apage(GPAGE0):fill16X68(0,144,511,511,0):er_upms():apage(GPAGE1)
endfunc

//------------------------------------
// judge3

func jd3()
int i,j,a,b
	if f<>1 then {
		vpageX68(9)
		apage(GPAGE0)
		fill16X68( 0,  0,511,511,8)
		for i=0 to 5
			box16X68(48+i*6,80+i*6,464-i*6,432-i*6,15)
		next
		fill16X68(79,111,433,401,2)
		kei(3)=kei(3)+1
		for i=0 to 3:cc(i)=kei(i):next
		for i=0 to 2
			for j=i+1 to 3
				if cc(i)<=cc(j) then a=cc(i):cc(i)=cc(j):cc(j) =a
			next
		next
		for i=0 to 3
			if cc(0)=kei(i) then jj=i:break
		next
		symbol16X68( 97,218,nam(jj)+localizedString("の優勝"," win!"),2,5,FONT,FNTSZ)
		a_play(snd(7))
		int s=sel(localizedString("もう一度やりますか？","Try again?"),2,2)
		if s=1 then {
			rd=1		 :fill16X68(0,0,511,511,0)
			apage(GPAGE1):fill16X68(0,0,511,511,0)
			apage(GPAGE2):fill16X68(0,0,511,511,8)
			vpageX68(15)
		} else f= 1
	}
endfunc

//------------------------------------
// owari

func owari()
	vpageX68(2):apage(GPAGE1)
	fill16X68(0,0,511,511,2)
	symbol16X68(252,400,localizedString("お疲れ様でした","See you again."),2,15,FONT,FNTSZ)
	a_play(snd(8))
endfunc

//------------------------------------

func scom2(hm,sm)
int i,is,bc=0
	for i=0 to hm-1
		is=sm+hm-1-i
		if p(jj,is)<b1 then bc=1:break
	next
	if bc=0 then is=0
	return(is)
endfunc

//------------------------------------

func scom3( hm,sm)
int i,is,bc=0
	for i=0 to hm-1
		is=sm+hm-1-i
		if p(jj,is)<b1 or p(jj,is)<b2 then bc=1:break
	next
	if bc=0 then is=0
	return(is)
endfunc

//------------------------------------

func scom4(hm,sm)
int i,is,bc=0
	for i=0 to hm-1
		is=sm+hm-1-i
		if p(jj,is)<b1 or p(jj,is)<b2 or p(jj,is)<b3 then bc=1:break
	next
	if bc=0 then is=0
	return(is)
endfunc

//------------------------------------

func sscom2()
int i,is
	for i=0 to m-1
		is=m-1-i
		if (p(jj,is)-1 )\13=(b1-1)\13 then break
	next
	return(is)
endfunc

//------------------------------------

func sscom3()
int i,is,a=0
	if b2>13 and b2<27 then {
		for i=0 to m-1
			is=m-1-i
			if (p(jj,is)-1)\13=(b1-1)\13 and p(jj,is)<b1 then a=1:break
		next
		if a = 0 then {
			for i=0 to m-1
			is=m-1-i
			if (p(jj,is)-1)\13=(b1-1)\13 then break
			next
		}
	} else is=sscom2()
	return(is)
endfunc

//------------------------------------

func sscom4()
int i,is,a=0
	if (b2>13 and b2<27) and (b3>13 and b3<27) then {
		for i=0 to m-1
			is=m-1-i
			if (p(jj,is)-1)\13=(b1-1)\13 and p(jj,is)<b1 then a=1:break
		next
		if a=0 then {
			for i = 0 to m-1
				is=m-1-i
				if (p(jj,is)-1)\13=(b1-1)\13 then break
			next
		}
	} else if (b2>13 and b2<27) and (b3<14 or b3>26) then {
		for i=0 to m-1
			is=m-1-i
			if (p(jj,is)-1)\13=(b1-1)\13 and (p(jj,is)<b1 or p(jj,is)<b3) then a=1:break
		next
		if a=0 then {
			for i=0 to m-1
				is=m-1-i
				if (p(jj,is)-1)\13=(b1-1)\13 then break
			next
		}
	} else if (b2<14 or b2>26) and (b3>13 and b3<27) then {
		for i=0 to m-1
			is=m-1-i
			if (p(jj,is)-1)\13=(b1-1)\13 and (p(jj,is)<b1 or p(jj,is)<b2) then a=1:break
		next
		if a=0 then {
			for i=0 to m-1
				is=m-1-i
				if (p(jj,is)-1)\13=(b1-1)\13 then break
			next
		}
	} else is=sscom2()
	return(is)
endfunc

//------------------------------------

func cdleft(k)
int i
	for i=0 to m-k
		cc(k+i)=cc(k+i+1):pp(k+i)=pp(k+i+1)
	next
endfunc

//------------------------------------

func int sel(title$;str,m,n)
str mm,nn
	switch m
		case 1:mm=localizedString("必　要","Necessary"):break
		case 2:mm=localizedString("Ｏ　Ｋ","Yes")
	endswitch
	switch n
		case 1:nn=localizedString("不　要","Unnecessary"):break
		case 2:nn=localizedString("やめる","No")
	endswitch

	dim str menues(1)
	menues(0)=mm
	menues(1)=nn
	int s
	switch selectMenu(title$,menues)
		case 0
			s=1
			break
		case 1
			s=2
			break
	endswitch
	cwait(40)
	return(s)
endfunc

//------------------------------------

func click( )
	if isLocalizeJapan() then {
		symbol16X68(176,48,"よければ画面を"	,1,15,FONT,FNTSZ)
		symbol16X68(208,84,"タップ"			,1,15,FONT,FNTSZ)
	} else {
		symbol16X68(172,48,"Please tap"		 ,1,15,FONT,FNTSZ)
		symbol16X68(172,84,"when you are ready",1,15,FONT,FNTSZ)
	}

	while getTouchStatus()=TOUCH_NONE
	endwhile
	//
	er_upms()
endfunc

//------------------------------------

func mkba()
	fill16X68( 3,145,279,383, 8)
	fill16X68(40,168,240,200,15)
	int i
	for i=0 to 3
		symbol16X68(i*56+40,344,nam(i),1,15,FONT,FNTSZ)
	next
endfunc

//------------------------------------

func dsban(j)
	er_ms()
	if isLocalizeJapan() then {
	symbol16X68(108,177,nam(j)+"の番",1,1,FONT,FNTSZ)
	} else {
	symbol16X68(108,177,nams(j)+" turn",1,1,FONT,FNTSZ)
	}
endfunc

//------------------------------------

func kachi(j)
	er_ms():symbol16X68( 48,177,nam(j)+localizedString("の勝ち"," win"),1,5,FONT,FNTSZ)
endfunc

//------------------------------------

func ha(ht)
	symbol16X68(134,177,localizedString("ハート ","Heart ")+str$(ht)+"枚",1,1,FONT,FNTSZ)
	a_play(snd(4))
endfunc

//------------------------------------

func ha0()
	symbol16X68(134,177,localizedString("ハート無し","No heart"),1,1,FONT,FNTSZ)
	a_play(snd(5))
endfunc

//------------------------------------

func dame()
	er_upms( )
	symbol16X68(200,48,localizedString("出せません","Can't throw"),1,5,FONT,FNTSZ)
	a_play(snd(3))
endfunc

//------------------------------------

func bacd(j,i)
	cardPut(j*56+32,225,c(j,i),NO)
	a_play(snd(1)):// mp3レベルで1+2してある
endfunc

//------------------------------------

func plcd()
int i
	if m>9 then {
		for i=0 to m-1
			cardPut(i*34+48,400,c(3,i),NO)
			line16X68(i*34+47,400,i*34+47,496,1)
			a_play(snd(1))
		next
	} else {
		for i=0 to m-1
			cardPut(i*50+48,400,c(3,i),NO)
			a_play(snd(1))
		next
	}
	symbol16X68(16,453,str$(m),1,15,FONT,FNTSZ)
endfunc

//------------------------------------

func htcd(jj,s)
int a,b,h
	a=(jj mod 2)*112+317:b=(jj\2)*104+176
	if gg(s)=26 then h=14 else h=gg(s)+1
	cardPut(a+mai(jj)*2,b,h,NO)
	line16X68( a+mai(jj)*2-1,b,a+mai(jj)*2-1,b+96,1)
	a_play(snd(1))
endfunc

//------------------------------------

func htmai()
int i
	for i=0 to 3
		  fill16X68((i mod 2)*112+294,(i \ 2)*104+228,(i mod 2)*112+310,(i\2)*104+244,0)
		symbol16X68((i mod 2)*112+294,(i \ 2)*104+228,str$(mai(i)),1,15,FONT,FNTSZ)
	next
endfunc

//------------------------------------

func cwait(t)
/* X68 10MHz n=500で42秒
	wait((42.0/500.0/5.0)*t)
//	int i
//	for i=0 to t*100:next
endfunc

//------------------------------------

func er_upms()
	fill16X68(161,3,319,143,0)
endfunc

//------------------------------------

func er_ms()
	fill16X68(40,168,240,200,15)
endfunc

//------------------------------------

func rule()
	// グラフィックを徐々に暗くする
	int pg
	float al=1.0
	repeat
		al=al-0.1
		for pg=GPAGE0 to GPAGE3
			apage(pg)
			gBackgroundAlpha(al)
			wait(0.02)
		next
	until al<0.4
	//
	if isLocalizeJapan() then {
	printgs(196,160,"ル ー ル")
	printgs( 60,190,"1 : カードの強さはA,K,Q,j ...4,3,2の順"	)
	printgs( 60,208,"2 : 各自が１枚づつ同じ種類を出さねばなりません")
	printgs(120,225,"但し手持ちが無ければ，何でもかまいません"		)
	printgs( 60,243,"3 : 最も強い札を出した人が4枚全部取ります"	)
	printgs( 60,261,"4 : 取った中にハートがあれば１枚につき-１点"	)
	printgs( 60,279,"5 : 持ち札が無くなるまで練り返します"		)
	printgs( 60,297,"6 : プラス点はハートを取らなかった人で分けます")
	printgs(120,314,"1人の時・・・+13点"						)
	printgs(120,331,"2人の時・・・+ 6点、残りは繰り越し"			)
	printgs( 60,349,"7 : 1人でハートの13枚すべてを取れば+12点、他の人は-4点"	)
	} else {
	printgs(196,160,"Rule")
	printgs( 60,190,"1 : The card strength order is A,K,Q,j ...4,3,2.")
	printgs( 60,208,"2 : Each person must throw a cards of the same suit.")
	printgs(120,225,"But if you do not have same suit, you can throw any card."	)
	printgs( 60,243,"3 : People that throw the strongest card takes all.")
	printgs( 60,261,"4 : If there is a heart in taken, point is decrease -1 point per sheet."	)
	printgs( 60,279,"5 : Repeat until you have no card.")
	printgs( 60,297,"6 : The plus scores are divvy up with person who did not take the heart.")
	printgs(120,314,"One person ・・・+13 points")
	printgs(120,331,"Two persons・・・+ 6 points , and so on.")
	printgs( 60,349,"7 : If you get all heart cards, you get +12 points and the other get -4 points."	)
	}
	// テキストを徐々に明るくする
	al=0.0
	repeat
		al=al+0.1
		tBackgroundAlpha(al)
		wait(0.02)
	until al>=1.0
	
	// 前のタッチが離されるのを待つ
	while getTouchStatus()<>TOUCH_NONE:endwhile
	// タッチされるのを待つ
	repeat
	until getTouchStatus()<>TOUCH_NONE
//	hitKey(NO)
	cls()
	for pg=GPAGE0 to GPAGE3
		apage(pg)
		gBackgroundAlpha(1)
	next
	apage(GPAGE1)
endfunc

func printgs(x;int,y;int,mes;str)
	locate(x,y):// グラフィック座標モード
	print mes
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
